import React from 'react';
import isEqual from 'react-fast-compare';

function useStyles(initialValue) {
  const [styles, setState] = React.useState(initialValue);
  const setStyles = React.useCallback(value => {
    const next = value instanceof Function ? value(styles) : value;
    setState(prev => isEqual(prev, next) ? prev : next);
  }, [styles]);
  return [styles, setStyles];
}

export default useStyles;